//
// C Implementation: std_lcd
//
// Description:
//
//
// Author: Thomas Klaehn <thomas.klaehn@web.de>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <avr/io.h>
#include "std_lcd.h"
#include "delay.h"

void enable(void){
	sbi(PORTC, 4);
	t5ms();
	cbi(PORTC, 4);
}

void set_command(char command){
	char low_nibble;

	low_nibble = command & 0x0F;		// seperate low nibble of command
	command = (command >> 4) & 0x0F;	// seperate high nibble of command

	outp(command, PORTC);
	enable();
	outp(low_nibble, PORTC);
	enable();
	t5ms();
}

void set_data(char data){
	char low_nibble;

	low_nibble = data & 0x0F;		// seperate low nibble of command
	data = (data >> 4) & 0xF0;		// seperate high nibble of command

	outp(data, PORTC);
	enable();
	outp((low_nibble | 0x10), PORTC);	// set Register Select bit
	enable();
	t5ms();
}


void init_std_lcd(void){
	t100ms();
	t100ms();
	t100ms();

	outp(3, PORTC);
	enable();
	t5ms();
	outp(3, PORTC);
	enable();
	t5ms();
	outp(3, PORTC);
	enable();
	t5ms();
	outp(2, PORTC);		// set 4 bit mode
	enable();
	t5ms();
	set_command(20);	// set lines & font
	set_command(6);		// Display on
	set_command(1);		// clear lcd;
};

void out_char_std_lcd(char charracter){
	char position = 0xF0;

	set_command(position);
	set_data(charracter);
}
